
Foreman - Feature #29991

Enable Zeitwerk autoload mode for Rails 6+

06/03/2020 07:26 AM - Lukas Zapletal

Status: Ready For Testing   

Priority: Normal   

Assignee: Oleh Fedorenko   

Category: Rails   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged: No Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/10131

  

Description

We should take advantage of the new and threadsafe autoloader: 

https://guides.rubyonrails.org/autoloading_and_reloading_constants.html#enabling-zeitwerk-mode

Subtasks:

Refactor # 33886: Fix early loads of constants Ready For Testing

  Refactor # 33887: Postpone CacheManager recache after rails is initialized Rejected

  Refactor # 33888: Postpone Setting load to after_initialization New

  Refactor # 33889: Postpone FogExtensions after initialization New

  Refactor # 33890: Require foreman/gettext directly Closed

  Refactor # 33891: require Telemetry constants Duplicate

  Refactor # 33892: Postpone setting validations to to_prepare Closed

  Refactor # 33949: Fix early load of plugin fact parsers Closed

  Refactor # 33950: Fix early load of ForemanInternal in initializer Closed

  Refactor # 33957: Require Foreman::Util in initializers Closed

  Refactor # 33964: Load Menu::Loader in 'to_prepare' Closed

  Refactor # 33967: Move basic ActiveRecord::Base custom extensions to ApplicationRecord Closed

  Refactor # 33968: Fix loading of Foreman::Telemetry in initializers Closed

  Refactor # 33975: Move menu loader from registries to services New

  Refactor # 33989: Delay Initialization of ApiPie that depends on Model classes Closed

  Refactor # 33991: Require /lib dependencies in initializers/foreman.rb Closed

  Refactor # 34005: Require middlewares properly Closed

  Refactor # 34006: Plugin and its rbac_support are using Role and Permission models too ... Closed

    Refactor # 34009: Add plugin after_initialize hook Closed

    Refactor # 34010: Add initialization method to RbacRegistry Closed

    Refactor # 34011: Move add_permissions_to_default_roles to rbac_registry Rejected

    Refactor # 34012: Move add_all_permissions_to_default_roles to RbacRegistry Rejected

    Refactor # 34013: Move add_resource_permissions_to_default_roles to RbacRegistry Rejected

    Refactor # 34014: Move role creation into RbacRegistry Rejected

    Refactor # 34015: Move permission creation in DB to RbacRegistry Rejected

  Refactor # 34350: Require 'foreman/telemetry' in ldap initializer Closed

  Refactor # 34353: Fix early load of fog_extensions Closed

Refactor # 33895: setup Zeitwerk inflector Ready For Testing

  Refactor # 33896: Document how plugins can adjust Zeitwerk inflector New

Refactor # 34007: Zeitwerk - remove 'foreman/provision' from init/foreman New

Refactor # 34137: Auto-loading & requiring /lib code Closed

  Refactor # 34138: Autoload ProxyAPI files from /app/services Closed

  Refactor # 34139: Move Foreman::Renderer from lib/ to app/services Closed
  Refactor # 34146: Move services from lib/foreman to app/services/foreman Closed

  Refactor # 34165: Require code from lib folder Closed

Refactor # 34646: Move initialization from application.rb into initializer Closed

Bug # 35419: Remove empty webpack_assets.rb file Closed

Related issues:

Related to Foreman - Tracker #24837: Rails 6.0 Tracker Closed

Related to Foreman - Tracker #28570: Rails 6.1 Tracker Closed

Related to foreman-tasks - Bug #34917: Tasks are loading ApplicationRecord to... Closed

Blocks Foreman - Tracker #34647: Rails 7.0 Tracker New

History

#1 - 06/03/2020 07:27 AM - Lukas Zapletal

- Related to Tracker #24837: Rails 6.0 Tracker added

#2 - 06/03/2020 07:28 AM - Lukas Zapletal

- Related to Tracker #28570: Rails 6.1 Tracker added

#3 - 11/01/2021 10:51 AM - Tomer Brisker

https://edgeguides.rubyonrails.org/classic_to_zeitwerk_howto.html

#4 - 11/25/2021 03:49 PM - Ondřej Ezr

- Tracker changed from Bug to Feature

#5 - 03/18/2022 11:36 AM - Ondřej Ezr

- Blocks Tracker #34647: Rails 7.0 Tracker added

#6 - 05/12/2022 05:26 PM - Ondřej Ezr

- Related to Bug #34917: Tasks are loading ApplicationRecord too soon and it derails Rails added

#7 - 04/18/2024 10:03 AM - Oleh Fedorenko

- Status changed from New to Assigned

- Assignee set to Oleh Fedorenko

#8 - 04/18/2024 10:06 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/10131 added
